{% extends "operators/base.html" %}{% load i18n static %}{% get_current_language as LANGUAGE_CODE %}
{% block title %}{% trans "Dashboard" %}{% endblock %}
{% block extrahead %}
<link href='{% static "fullcalendar5/lib/main.css" %}' rel='stylesheet' />
<script src='{% static "fullcalendar5/lib/main.js" %}'></script>
<script src='{% static "fullcalendar5/lib/locales/it.js" %}'></script>
<script src='{% static "fullcalendar5/lib/locales/de.js" %}'></script>
<script src='{% static "bootstrap-menu1/BootstrapMenu.min.js" %}'></script>

<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>

<style>
    .btn-circle.btn-xl {
        width: 70px;
        height: 70px;
        padding: 10px 16px;
        border-radius: 35px;
        font-size: 24px;
        line-height: 1.33;
    }

    .btn-circle {
        width: 30px;
        height: 30px;
        padding: 6px 0px;
        border-radius: 15px;
        text-align: center;
        font-size: 12px;
        line-height: 1.42857;
    }

    .floating {
        position: fixed;
        right: 3rem;
        bottom: 3rem;
        z-index: 999!important;
        box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.16), 0 0 0 1px rgba(0, 0, 0, 0.08);
    }
</style>

{% endblock %}
{% block content %}

<main>

    <h1 class="display-2 text-dark fw-normal pb-3">
        <a href="{% url 'operators:new-reservation' %}" class="me-3">
            <i class="fa fa-plus"></i>
        </a>
        {% trans "Plan RESERVATIONS" %}
    </h1>

    <button type="button" class="btn btn-primary btn-circle btn-xl floating"
        onclick="location.href='{% url 'operators:new-reservation' %}';">
        <i class="fa fa-plus"></i>
    </button>

    <div id='calendar' style="background-color: white; padding: 10px;"></div>

</main>

<div class="modal fade" id="trip-leg-assign-driver" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">{% trans "Assign driver" %}</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <h6 class="mt-1">{% trans "Driver" %}</h6>
                <select id="driver-ajax" class="form-control"></select>
            </div>
            <div class="modal-footer justify-content-between">
                <div>
                    <button class="btn btn-danger" id="trip-leg-deassign-submit" type="button">
                        <div class="spinner-border text-light align-items-center d-none" style="width: 1rem; height: 1rem;" role="status">
                            <span class="sr-only">Loading...</span>
                        </div>
                        &nbsp;{% trans "Remove assignation" %}
                    </button>
                </div>
                <div>
                    <button class="btn btn-outline-secondary mx-1" type="button" data-bs-dismiss="modal">{% trans "Close" %}</button>
                    <button class="btn btn-success" id="trip-leg-assign-submit" type="button">
                        <div class="spinner-border text-light align-items-center d-none" style="width: 1rem; height: 1rem;" role="status">
                            <span class="sr-only">Loading...</span>
                        </div>
                        &nbsp;{% trans "Confirm" %}
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>


<script type="text/javascript">
    $(document).ready(function () {
        $('#driver-ajax').select2({
            ajax: {
                url: "{% url 'operators:driver-ajax-query' %}",
                type: "POST",
                dataType: "json",
                delay: 150,
                data: function (params) { 
                    return {
                        "q": params.term, 
                        "csrfmiddlewaretoken": "{{ csrf_token }}",
                        "trip_start": window.selectedTripLeg.extendedProps.startTripStage.estimatedTime,
                        "trip_end": window.selectedTripLeg.extendedProps.endTripStage.estimatedTime
                    }; 
                },
                processResults: function (data, params) { return { results: data } }
            },
            placeholder: `{% trans "Start typing the driver's name" %}`,
            minimumInputLength: 2,
            templateResult: function (driver) {
                if (driver.fullname == undefined) return $("");
                var out = $(
                    `<div>
                        <span class='h4 fw-normal'><i class='fas fa-user'></i>&nbsp;${driver.fullname}</span><br/>
                        <span class='h5 fw-normal'><i class="fas fa-clipboard-check"></i>&nbsp;&nbsp;${driver.hasSuitableDriverShift ? "{% trans 'Has a driver shift for this trip' %}" : "{% trans 'Does not have a driver shift for this trip'%}"}</span><br/>
                        <span class='h5 fw-normal'><i class="fas fa-user-check"></i>&nbsp;${driver.isAssignedToSimultaneousTripLeg ? "{% trans 'Already assigned to another trip leg on this timespan' %}" : "{% trans 'Not assigned to other trip legs on this timespan'%}"}</span>
                    </div>`
                );
                return out;
            },
            templateSelection: function (driver) {
                return !!driver.fullname ? $("<span class='h5 fw-normal'>"
                    + driver.fullname + "</span>") : driver.text;
            },
            dropdownParent: $('#trip-leg-assign-driver .modal-content'),
            width: '100%'
        });
        $("#driver-ajax").on("select2:select", function (e) {
            window.driver = e.params.data;
        });

        window.calendar = new FullCalendar.Calendar(document.getElementById('calendar'), {
            initialView: 'timeGridWeek',
            slotMinTime: '07:00',
            slotMaxTime: '21:00',
            slotDuration: '00:15:00',
            allDaySlot: false,
            locale: '{{ LANGUAGE_CODE }}',
            weekends: true,
            hiddenDays: [ 0 ],
            nowIndicator: true,
            contentHeight: 'auto',
            eventTimeFormat: {
                hour: 'numeric',
                minute: '2-digit',
                meridiem: false,
                hour12: false,
                omitZeroMinute: false
            },
            headerToolbar: {
                left: 'prev,next today',
                center: 'title',
                right: 'dayGridMonth,timeGridWeek,timeGridDay'
            },
            eventSources: [{
                url: "{% url 'operators:reservation-ajax-query' %}",
                method: "POST",
                extraParams: { "csrfmiddlewaretoken": "{{ csrf_token }}" },
                failure: function () { alert("{% trans 'Error while retrieving data from server' %}"); }
            }],
            eventDidMount: function (info) {
                var el = $(info.el);
                el.attr('tabindex', '0');
                el.attr('data-bs-trigger', 'hover');
                el.attr('data-bs-toggle', 'popover');
                el.attr('data-bs-html', 'true');
                el.on('click', function() {
                    const c = this;
                    $(this).popover('dispose');
                    setTimeout(function() {
                        var P = $($(c).attr('data-bs-content'));
                        P.find('.trip-leg-actions-hint').addClass('d-none');
                        P.find('.trip-leg-actions').removeClass('d-none');
                        $(c).attr('data-bs-content', P.prop('outerHTML'));
                        $(c).popover({
                            trigger: 'click'
                        })
                        $(c).popover('show');
                    }, 200);
                })
                
                var startDate = new Date(info.event.extendedProps.startTripStage.estimatedTime);
                var endDate = new Date(info.event.extendedProps.endTripStage.estimatedTime);

                var startTime = `${String(startDate.getHours()).padStart(2, '0')}:${String(startDate.getMinutes()).padStart(2, '0')}`;
                var endTime = `${String(endDate.getHours()).padStart(2, '0')}:${String(endDate.getMinutes()).padStart(2, '0')}`;
                
                var startLocation = !!info.event.extendedProps.startTripStage.name ? 
                    info.event.extendedProps.startTripStage.name : info.event.extendedProps.startTripStage.shortAddress;
                var endLocation = !!info.event.extendedProps.endTripStage.name ? 
                    info.event.extendedProps.endTripStage.name : info.event.extendedProps.endTripStage.shortAddress;
                var driverShift = info.event.extendedProps.driverShift;
                
                el.attr('title', info.event.title);
                el.attr('data-bs-content', `
                <div class="p-1 d-flex flex-column popover-body">
                    <p><i class="fas fa-calendar-day"></i>&nbsp;&nbsp;${startDate.toLocaleDateString()}</p>
                    <p><i class="fas fa-address-card"></i>&nbsp;&nbsp;${driverShift.driver ? driverShift.driver : "{% trans 'Unassigned' %}"}</p>
                    <p><i class="fas fa-car"></i>&nbsp;&nbsp;${driverShift.vehicle ? driverShift.vehicle : "{% trans 'Unassigned' %}"}</p>
                    <p><i class="fas fa-phone"></i>&nbsp;&nbsp;${info.event.extendedProps.phone_number}</p>
                    <hr>
                    <ul class="list-group list-group-flush">
                        <li class="list-group-item border-0"><strong>${startTime}</strong>&nbsp;&bull;&nbsp;${startLocation}</li>
                        <li class="list-group-item border-0"><strong>${endTime}</strong>&nbsp;&bull;&nbsp;${endLocation}</li>
                    </ul>
                    <div class="alert alert-primary mt-3 mb-0 trip-leg-actions-hint">
                        {% trans 'Click to expand actions related to this event' %}
                    </div>
                    <div class="d-none trip-leg-actions d-flex flex-column">
                        <a class="btn btn-primary mt-4 action-assign" role="button"><i class="fas fa-id-card" aria-hidden="true"></i>&nbsp; {% trans 'Assign driver' %}</a>
                        <a class="btn btn-primary mt-2 action-print ${driverShift.driver ? "" : "d-none"}" href="{% url 'operators:trip-sheet-print' %}${info.event.extendedProps.tlid}" role="button" target="_blank"><i class="fas fa-print" aria-hidden="true"></i>&nbsp; {% trans 'Print' %}</a>
                        <a class="btn btn-primary mt-2 action-edit" href="{% url 'operators:edit-reservation' %}${info.event.extendedProps.rid}" role="button"><i class="fas fa-edit" aria-hidden="true"></i>&nbsp; {% trans 'Edit' %}</a>
                        <a class="btn btn-danger mt-2 action-delete" href="{% url 'operators:delete-trip-leg' %}${info.event.extendedProps.tlid}" role="button"><i class="fas fa-trash" aria-hidden="true"></i>&nbsp; {% trans 'Delete' %}</a>
                        <a class="btn btn-success mt-2 action-replicate" href="{% url 'operators:new-reservation-from-trip-leg' %}${info.event.extendedProps.tlid}" role="button"><i class="fas fa-clone" aria-hidden="true"></i>&nbsp; {% trans 'Replicate' %}</a>
                    </div>
                </div>`);
                new bootstrap.Popover(el);
            },
            eventClick: function(evt) {
                evt.jsEvent.preventDefault();
                window.selectedTripLeg = evt.event;
                if (!!window.selectedTripLeg.extendedProps.driverShift.driver) {
                    $('#trip-leg-assign-driver #trip-leg-deassign-submit').removeClass('d-none');
                } else {
                    $('#trip-leg-assign-driver #trip-leg-deassign-submit').addClass('d-none');
                }
            }
        });
        window.calendar.render();

        $('body').on('click', function (e) {
            $('[data-bs-toggle="popover"]').each(function () {
                if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                    const wrapper = this;
                    $(this).popover('dispose');
                    setTimeout(function() {
                        var P = $($(wrapper).attr('data-bs-content'));
                        P.find('.trip-leg-actions').addClass('d-none');
                        P.find('.trip-leg-actions-hint').removeClass('d-none');
                        $(wrapper).attr('data-bs-content', P.prop('outerHTML'));
                        $(wrapper).popover({
                            trigger: 'hover'
                        });
                    }, 200);
                }
            });
        });

        $('body').on("click", ".action-assign", function (evt) {
            $(evt.target).closest('.popover').popover('hide');
            $('#trip-leg-assign-driver').modal('show');
        });

        $("#trip-leg-print").off('click').on('click', function () {
            window.location = "/operators/reservation/trip_leg/" + window.selectedTripLeg.extendedProps.tlid + "/print";
        });

        $('#trip-leg-deassign-submit').off('click').on('click', function() {
            fetch('{% url "operators:trip-leg-driver-deassociation" %}', {
                method: 'POST',
                body: new URLSearchParams({
                    't': window.selectedTripLeg.extendedProps.tlid,
                    'csrfmiddlewaretoken': "{{ csrf_token }}"
                })
            }).then(res => {
                $('#trip-leg-deassign-submit .spinner-border').addClass('d-none');
                if (res.ok) {
                    $('#trip-leg-assign-driver').modal('hide');
                    window.calendar.refetchEvents();
                } else {
                    $('#trip-leg-assign-driver .modal-body').prepend($(`
                        <div class="alert alert-danger alert-dismissible fade show mb-3" role="alert">
                            {% trans 'An error occurred during the operation. Please retry.' %}
                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                        </div>
                    `))
                }
            }).catch(error => {
                $('#trip-leg-deassign-submit .spinner-border').addClass('d-none');
                $('#trip-leg-assign-driver .modal-body').prepend($(`
                        <div class="alert alert-danger alert-dismissible fade show mb-3" role="alert">
                            {% trans 'An error occurred during the operation. Please retry.' %}
                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                        </div>
                    `))
            });
            $('#trip-leg-deassign-submit .spinner-border').removeClass('d-none');
        })

        $('#trip-leg-assign-submit').off('click').on('click', function() {
            var driver = $('#driver-ajax').select2('data')[0];
            if (!driver) {
                return;
            }
            $('#trip-leg-assign-driver .modal-body .alert').remove();
            fetch('{% url "operators:trip-leg-driver-association" %}', {
                method: 'POST',
                body: new URLSearchParams({
                    't': window.selectedTripLeg.extendedProps.tlid,
                    'ds': driver.driverShifts[0].id,
                    'csrfmiddlewaretoken': "{{ csrf_token }}"
                })
            }).then(res => {
                $('#trip-leg-assign-submit .spinner-border').addClass('d-none');
                if (res.ok) {
                    $('#trip-leg-assign-driver').modal('hide');
                    window.calendar.refetchEvents();
                } else {
                    $('#trip-leg-assign-driver .modal-body').prepend($(`
                        <div class="alert alert-danger alert-dismissible fade show mb-3" role="alert">
                            {% trans 'An error occurred during the operation. Please retry.' %}
                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                        </div>
                    `))
                }
            }).catch(error => {
                $('#trip-leg-assign-submit .spinner-border').addClass('d-none');
                $('#trip-leg-assign-driver .modal-body').prepend($(`
                        <div class="alert alert-danger alert-dismissible fade show mb-3" role="alert">
                            {% trans 'An error occurred during the operation. Please retry.' %}
                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                        </div>
                    `))
            });
            $('#trip-leg-assign-submit .spinner-border').removeClass('d-none');
        })
    });
</script>

{% endblock %}